您的位置:首页 > 其它

HDU 1078 FatMouse and Cheese(记忆化搜索 Or DP)

2017-04-18 22:21 411 查看


P - FatMouse and Cheese

 HDU
- 1078

FatMouse has stored some cheese in a city. The city can be considered as a square grid of dimension n: each grid location is labelled (p,q) where 0 <= p < n and 0 <= q < n. At each grid location Fatmouse has hid between 0 and 100
blocks of cheese in a hole. Now he's going to enjoy his favorite food. 

FatMouse begins by standing at location (0,0). He eats up the cheese where he stands and then runs either horizontally or vertically to another location. The problem is that there is a super Cat named Top Killer sitting near his hole, so each time he can run
at most k locations to get into the hole before being caught by Top Killer. What is worse -- after eating up the cheese at one location, FatMouse gets fatter. So in order to gain enough energy for his next run, he has to run to a location which have more blocks
of cheese than those that were at the current hole. 

Given n, k, and the number of blocks of cheese at each grid location, compute the maximum amount of cheese FatMouse can eat before being unable to move. 

InputThere are several test cases. Each test case consists of 

a line containing two integers between 1 and 100: n and k 

n lines, each with n numbers: the first line contains the number of blocks of cheese at locations (0,0) (0,1) ... (0,n-1); the next line contains the number of blocks of cheese at locations (1,0), (1,1), ... (1,n-1), and so on. 

The input ends with a pair of -1's. 

OutputFor each test case output in a line the single integer giving the number of blocks of cheese collected. 

Sample Input
3 1
1 2 5
10 11 6
12 12 7
-1 -1


Sample Output
37


题意:老鼠每次只能走k步停下来,停下的这个位置只能比上一个停留的位置大,并获取其价值,每次只能水平或垂直走,问最大能得到的价值在n*n的格子上,每个点各有若干块奶酪,胖老鼠从左上角出发,每次最多走k步(只能直走),且下一点必须比这一点的奶酪多,问最多能吃到多少块奶酪。

#include <stdio.h>
#include <string.h>
#include <algorithm>
using namespace std;

int n,k,dp[105][105],a[105][105];
int to[4][2] = {1,0,-1,0,0,1,0,-1};

int check(int x,int y)
{
if(x<1 || y<1 || x>n || y>n)
return 1;
return 0;
}

int dfs(int x,int y)
{
int i,j,l,ans = 0;
if(!dp[x][y])
{
for(i = 1; i<=k; i++)
{
for(j = 0; j<4; j++)
{
int xx = x+to[j][0]*i;
int yy = y+to[j][1]*i;
if(check(xx,yy))
continue;
if(a[xx][yy]>a[x][y])
ans = max(ans,dfs(xx,yy));
}
}
dp[x][y] = ans+a[x][y];
}
return dp[x][y];
}

int main()
{
int i,j;
while(~scanf("%d%d",&n,&k),n>0&&k>0)
{
for(i = 1; i<=n; i++)
for(j = 1; j<=n; j++)
scanf("%d",&a[i][j]);
memset(dp,0,sizeof(dp));
printf("%d\n",dfs(1,1));
}

return 0;
}


这里需要一个排序转化,详见代码注释

DP思想:dp[x][y]=max(dp[x][y],dp[xx][y]+a[x][y])     (xx,y)位置是上一个能到达当前位置(x,y)的位置

#include<stdio.h>
#include<algorithm>
#include<string.h>
#include<iostream>
using namespace std;
const int MAXN=110;

int a[MAXN][MAXN];
int dp[MAXN][MAXN];  ///dp[i][j]是在i j点所能获得的最大的值

struct Node
{
int x,y,val;
}node[MAXN*MAXN];

bool cmp(Node a,Node b)
{
return a.val<b.val;
}

int main()
{
int n,k;
while(scanf("%d%d",&n,&k)==2)
{
if(n==-1&&k==-1)break;
int cnt=0;
for(int i=0;i<n;i++)
for(int j=0;j<n;j++)
{
scanf("%d",&a[i][j]);
if(i!=0||j!=0)
{
node[cnt].x=i;
node[cnt].y=j;
node[cnt++].val=a[i][j];
}
}
sort(node,node+cnt,cmp);  ///这对于搜索转dp问题很关键,因为这里只能从小的向大的走,所以先更新当前格子val,
///这样后面用到当前位置的dp[][]时候就已经有值了,很巧妙,没有这层限制关系(从小到大)
///是转不成DP的!!!
memset(dp,-1,sizeof(dp));
dp[0][0]=a[0][0];
int ans=dp[0][0];
for(int i=0;i<cnt;i++)
{
int x=node[i].x;
int y=node[i].y;

for(int xx=max(0,x-k);xx<=min(n-1,x+k);xx++) ///左右方向DP
{
if(a[xx][y]>=a[x][y])continue;
if(dp[xx][y]==-1)continue;   ///虽然满足了从小到大限制条件,能从(xx,y)到当前位置,但是(xx,y)位置都是没法进入
///也就最终无法从(xx,y)到当前位置了
dp[x][y]=max(dp[x][y],dp[xx][y]+a[x][y]);
}
for(int yy=max(0,y-k);yy<=min(n-1,y+k);yy++)  ///上下方向DP
{
if(a[x][yy]>=a[x][y])continue;
if(dp[x][yy]==-1)continue;   ///虽然满足了从小到大限制条件,能从(xx,y)到当前位置,但是(xx,y)位置都是没法进入
///也就最终无法从(xx,y)到当前位置了
dp[x][y]=max(dp[x][y],dp[x][yy]+a[x][y]);
}
ans=max(ans,dp[x][y]);
}
printf("%d\n",ans);
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: